<?php
/**********************************************************************************
* Subs-BoardNews.php                                                              *
***********************************************************************************
* for use with SMF: Simple Machines Forum                                         *
* =============================================================================== *
* Software Version:           BoardNews 1.2                                       *
* Software by:                Oskari Rauta/Jake Irons (http://www.roadrunner.cx)  *
* Copyright 2007 by:          RoadRunner.cx (http://www.roadrunner.cx)            *
* Updates at:                 http://www.simplemachines.org                       *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it.        *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* The latest version can always be found at http://www.simplemachines.org.        *
**********************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

/*	This file contains function(s) needed by BoardNews MOD.

	function genboardnews()
		- is called to fill $context['random_news_line'];
*/

function genboardnews()
{
global $context, $boards, $boardList, $cat_tree, $modSettings, $db_prefix, $sourcedir, $user_info, $txt, $boarddir;

if (!$modSettings['bnews_enabled'])
	return;

require_once($sourcedir . '/Subs-Boards.php');
require_once($boarddir . '/SSI.php');

$context['bnews'] = array();
$amountBoards = 0;
$newsBoards = array();
$newsID = 0;

getBoardTree();

foreach ($cat_tree as $catid => $tree)
	foreach ($boardList[$catid] as $boardid)
		{
			++$amountBoards;
			if (isset($modSettings['bnews_id' . $amountBoards]))
				if ($modSettings['bnews_id' . $amountBoards])
					$newsBoards[] = $boardid;
		}

$newsItems = ssi_boardNews($newsBoards, $modSettings['bnews_max'], null, null, 'noecho');

if (count($newsItems) == 0)
	return;

loadLanguage('index');

if (isset($context['random_news_line']))
    if ($context['random_news_line'] != '')
	$context['random_news_line'] .= '</span><br/>
<span class="smalltext" style="visibility: hidden;"><b>' . $txt[102] . '</b>: ';

foreach ($newsItems as $newsItem)
	$context['random_news_line'] .= (($newsID++==0) ? '' : ('<span class="smalltext" style="visibility: hidden;"><b>' . $txt[102] . '</b>: ')) . '
	</span><span class="smalltext">
		<a href="' . $newsItem['href'] . '" style="text-decoration:none;" title="' . (strlen(strip_tags(preg_replace('#\[(.+?)\]#ie', '', $newsItem['body']))) > $modSettings['bnews_hover'] ? ((substr(strip_tags(preg_replace('#\[(.+?)\]#ie', '', $newsItem['body'])), 0, $modSettings['bnews_hover'] - 2)) . '..') : strip_tags(preg_replace('#\[(.+?)\]#ie', '', $newsItem['body']))) . '" alt="' . (strlen($newsItem['body']) > $modSettings['bnews_hover'] ? ((substr($newsItem['body'], 0, $modSettings['bnews_hover'] - 2)) . '..') : strip_tags(preg_replace('#\[(.+?)\]#ie', '', $newsItem['body']))) . '">
' . (strlen(strip_tags(preg_replace('#\[(.+?)\]#ie', '', $newsItem['subject']))) > $modSettings['bnews_chars'] ? ((doUBBC(substr(strip_tags(preg_replace('#\[(.+?)\]#ie', '', $newsItem['subject'])), 0, $modSettings['bnews_chars'] - 2),true)) . '..') : doUBBC(strip_tags(preg_replace('#\[(.+?)\]#ie', '', $newsItem['subject'])),true)) . '</a><br/></span>';

$context['random_news_line'] = substr($context['random_news_line'], 0, -7);
}

?>